var bo = {};

function init_canvas() {
    bo.canvas = document.getElementById( 'canvas' );
    bo.ctx = bo.canvas.getContext( '2d' );
    bo.canvas_h = bo.canvas.height;
    bo.canvas_w = bo.canvas.width;
}

function init_ball() {
    bo.x = bo.canvas_w / 2;
    bo.y = bo.canvas_h / 2;
    bo.r = 10;
    bo.fill = "rgba( 0, 0, 0, 1 )";  /* RGB opacity */
    bo.dx = 1;
    bo.dy = 4;
}

function clear_rect() {
    bo.ctx.clearRect( 0, 0, bo.canvas_w, bo.canvas_h );
}

function draw_circle( x, y, r, fill ) {
    var ctx = bo.ctx;  // dereference

    ctx.fillStyle = fill;
    ctx.beginPath();
    ctx.arc( x, y, r, 0, Math.PI*2, true );
    ctx.closePath();
    ctx.fill();
}

function move_ball(){
    var x = bo.x,
        y = bo.y,
        r = bo.r;

    if (x + bo.dx + r > bo.canvas_w || x + bo.dx - r < 0)
        bo.dx = -bo.dx;
    if (y + bo.dy + r > bo.canvas_h || y + bo.dy - r < 0)
        bo.dy = -bo.dy;
    
    bo.x += bo.dx;
    bo.y += bo.dy;
}

function draw() {
    clear_rect();
    move_ball();
    draw_circle( bo.x, bo.y, bo.r, bo.fill );
}

function runCode() {
    init_canvas();
    init_ball();

    /* start event loop */
    bo.intervalId = setInterval( draw, 10 );
}