var canvas;
var ctx;
var canvas_w, canvas_h;

var intervalId = 0;  /* stop event loop */

/* ball */
var x, y;
var r;
var fill;  /* RGB transparency */
var dx, dy;

/* paddle */
var  paddle_x;
var  paddle_w, paddle_h;
var  paddle_fill;


function clear_rect(){
    ctx.clearRect(0, 0, canvas_w, canvas_h);
}

function draw_circle(x, y, r, fill) {
    ctx.fillStyle = fill;
    ctx.beginPath();
    ctx.arc(x, y, r, 0, Math.PI*2, true);
    ctx.closePath();
    ctx.fill();
}

function draw_rect(x, y, w, h, fill) {
    ctx.fillStyle = fill;
    ctx.beginPath();
    ctx.rect(x, y, w, h);
    ctx.closePath();
    ctx.fill();
}

function move_ball(){
    if (x + dx + r > canvas_w || x + dx - r < 0)
        dx = -dx;

    if (y + dy - r < 0)   /* ball at the top */
        dy = -dy;
    else
        if (y + dy + r > canvas_h - paddle_h) {   /* ball at the bottom */
            if (x > paddle_x && x < paddle_x + paddle_w)
                dy = -dy;
            else if (y + dy + r > canvas_h) {
                //game over, so stop the animation
                clearInterval(intervalId);
            }
        }

    x += dx;
    y += dy;
}

function draw() {
    clear_rect();
    draw_circle(x, y, r, fill);
    draw_rect(paddle_x, canvas_h - paddle_h, paddle_w, paddle_h, paddle_fill);
    move_ball();
}

function init_canvas() {
    canvas = document.getElementById('canvas');
    ctx = canvas.getContext('2d');
    canvas_h = canvas.height;
    canvas_w = canvas.width;
}

function init_ball() {
    x = canvas_w / 2;
    y = canvas_h / 2;
    r = 10;
    fill = "rgba(0, 0, 0, 1)";  /* RGB opacity */
    dx = 1;
    dy = 4;
}

function init_paddle(){
    paddle_x = canvas_w / 2;
    paddle_h = 10;
    paddle_w = 75;
    paddle_fill = "rgba(127, 127, 127, 1)";
}

function runCode() {
    init_canvas();
    init_ball();
    init_paddle();

    /* start event loop */
    intervalId = setInterval(draw, 10);
}